//	GIFC[WA
//	Version 0.10	2000.07.18
//	Version 0.11	2000.08.13
//
//	GIF Concatenation "GifCat"
//	Copyright (C) CONFLICT 2000.  All rights reserved.

import java.util.*;
import java.io.*;

/**
 *	GIFt@CA邽߂̃NXłB
 *	Ƃقَgifcat.plQlɂĂ܂B
 *
 *	@author	ӂ肭
 */
public class GifCat {
	//	C[W̘A
	/**
	 *	GIFC[W̘AsȂ܂B
	 *
	 *	@param	images	AΏۂGifImage^̗񋓁B
	 *	@return	AGIFC[WB
	 *	@throws	Exception
	 *			ׂẴC[WColor Table`ĂȂꍇB
	 */
	public static byte[] concatImage(Enumeration images) throws Exception {
		Vector imageVec = new Vector();
		GifImage image1;
		int logicalScreenWidth = 0;
		int logicalScreenHeight = 0;
		int w;
		int sizeOfImage = 13;						//	wb_Œ蒷
		
		//	C[Wf[^̏Wv
//		System.out.println("Analyze each images.");
		Enumeration e;
		Vector colorTableVec = new Vector();
		
		for(e = images; e.hasMoreElements(); ) {
			image1 = (GifImage)e.nextElement();
			imageVec.add(image1);
			
			//	ColorTable̎擾
			if(image1.getGlobalColorTableFlag()) {
				colorTableVec.add(image1.getGlobalColorTable());
			}
			else {
				colorTableVec.add(null);
			}
			
			logicalScreenWidth += image1.getLogicalScreenWidth();
			w = image1.getLogicalScreenHeight();
			if(logicalScreenHeight < w) {
				logicalScreenHeight = w;
			}
			
			sizeOfImage += (19 + image1.getImageData().length);
		}
		
		//	ColorTablẽ`FbN
//		System.out.println("Check table size.");
		boolean useLocalColorTable = false;
		byte[] globalColorTable = null;
		int sumOfTableSize = 0;
		for(e = colorTableVec.elements(); e.hasMoreElements(); ) {
			byte[] colorTable = (byte[])e.nextElement();
			
			if(globalColorTable == null) {			//	ŏ?
				globalColorTable = colorTable;
			}
			else if(colorTable != null) {			//	ColorTable`?
				if(!compareByteArray(globalColorTable, colorTable)) {
					//	globalƈقȂȂAe摜œƎColorTableg
					useLocalColorTable = true;
				}
			}
			if(colorTable != null) {
				sumOfTableSize += colorTable.length;
			}
		}
		
		//	摜TCYicolorTable)̌vZ
		if(!useLocalColorTable) {
			if(globalColorTable == null) {			//	ColorTable`Ȃ?
				throw(new Exception());
			}
			sizeOfImage += globalColorTable.length;
		}
		else {
			sizeOfImage += sumOfTableSize;
		}
		sizeOfImage++;								//	end mark
		
		//	AC[W̍쐬
//		System.out.println("Concat images.");
		int i;
		byte[] image = new byte[sizeOfImage];
		int index = 0;
		int gifIndex = 0;
		
		for(gifIndex = 0; gifIndex < imageVec.size(); gifIndex++) {
//			System.out.println("Processing image No." + (gifIndex+1) + ".");
			image1 = (GifImage)imageVec.get(gifIndex);
			
			int packedFields18 = image1.getPackedFields18();
			int packedFields20 = image1.getPackedFields20();
			
			//	ŏGIF݂̂̏
			if(gifIndex == 0) {
				//	wb_
				byte[] header = (new String("GIF89a")).getBytes();
				copyBytes(image, index, header);
				index += 6;
				
				unpackIntToByte(logicalScreenWidth, image, index);	index += 2;
				unpackIntToByte(logicalScreenHeight, image, index);	index += 2;
				
				if(useLocalColorTable) {
					packedFields18 &= 0x7f;
				}
				image[index++] = (byte)packedFields18;
				image[index++] = (byte)image1.getBackgroundColorIndex();
				image[index++] = (byte)image1.getPixelAspectRatio();
				
				if(!useLocalColorTable) {
					copyBytes(image, index, globalColorTable);
					index += globalColorTable.length;
				}
			}
			
			//	e摜̏
			image[index++] = (byte)0x21;
			image[index++] = (byte)0xf9;
			image[index++] = (byte)0x04;
			image[index++] = (byte)(image1.getPackedFields23() | 
								(image1.getTransparentColorFlag() ? 0x01 : 0));
			image[index++] = (byte)0x00;
			image[index++] = (byte)0x00;
			image[index++] = (byte)image1.getTransparentColorIndex();
			image[index++] = (byte)0x00;
			image[index++] = (byte)0x2c;
			w = image1.getImageWidth();
			unpackIntToByte(w * gifIndex, image, index);			index += 2;
			image[index++] = (byte)0x00;
			image[index++] = (byte)0x00;
			unpackIntToByte(w, image, index);						index += 2;
			unpackIntToByte(image1.getImageHeight(), image, index);	index += 2;
			//	܂17bytes
			
			if(useLocalColorTable) {
				packedFields20 |= 0x80;
				packedFields20 &= 0xf8;
				packedFields20 |= (packedFields18 & 0x07);
				image[index++] = (byte)packedFields20;
				
				byte[] table = (byte[])(colorTableVec.elementAt(gifIndex));
				copyBytes(image, index, table);
				index += table.length;
			}
			else {
				image[index++] = (byte)packedFields20;
			}
			
			image[index++] = (byte)image1.getLzwMinimumCodeSize();
			//	܂19(+colorTable)bytes
			
			byte[] body = image1.getImageData();
			copyBytes(image, index, body);
			index += body.length;
		}
		image[index++] = (byte)0x3b;
		
		return image;
	}
	
	//	int2byteɂ
	private static void unpackIntToByte(int value, byte[] array, int offset) {
		array[offset]   = (byte)(value & 0xff);
		array[offset+1] = (byte)((value >> 8) & 0xff);
	}
	
	//	bytẽRs[
	private static void copyBytes(byte[] dst, int offset, byte[] src) {
		for(int i = 0; i < src.length; i++) {
			dst[offset + i] = src[i];
		}
	}
	
	//	byte̔r
	private static boolean compareByteArray(byte[] a1, byte[] a2) {
		if(a1 == null || a2 == null) {
			return false;
		}
		if(a1.length != a2.length) {
			return false;
		}
		for(int i = 0; i < a1.length; i++) {
			if(a1[i] != a2[i]) {
				return false;
			}
		}
		return true;
	}
}
